searchData={"content_type":"text/markdown","items":[{"doc":"Elixir port of NanoID ([https://github.com/ai/nanoid](https://github.com/ai/nanoid)), a tiny, secure URL-friendly unique string ID generator.\n\n**Safe.** It uses cryptographically strong random APIs and guarantees a proper distribution of symbols.\n\n**Compact.** It uses a larger alphabet than UUID (A-Za-z0-9_-) and has a similar number of unique IDs in just 21 symbols instead of 36.","ref":"Nanoid.html","title":"Nanoid","type":"module"},{"doc":"Generates a secure NanoID using the default alphabet.","ref":"Nanoid.html#generate/0","title":"Nanoid.generate/0","type":"function"},{"doc":"Generate a NanoID with the default size of 21 characters.\niex> Nanoid.generate()\n\"mJUHrGXZBZpNX50x2xkzf\"","ref":"Nanoid.html#generate/0-example","title":"Example - Nanoid.generate/0","type":"function"},{"doc":"Generates a secure NanoID using the default alphabet.","ref":"Nanoid.html#generate/1","title":"Nanoid.generate/1","type":"function"},{"doc":"Generate a secure NanoID with a custom size of 64 characters.\niex> Nanoid.generate(64)\n\"wk9fsUrhK9k-MxY0hLazRKpcSlic8XYDFusks7Jb8FwCVnoQaKFSPsmmLHzP7qCX\"","ref":"Nanoid.html#generate/1-example","title":"Example - Nanoid.generate/1","type":"function"},{"doc":"Generates a secure NanoID using a custom size and an individual alphabet.","ref":"Nanoid.html#generate/2","title":"Nanoid.generate/2","type":"function"},{"doc":"Generate a secure NanoID with the default size of 21 characters and an individual alphabet.\n    iex> Nanoid.generate(21, \"abcdef123\")\n    \"d1dcd2dee333cae1bfdea\"\n\nGenerate a secure NanoID with custom size of 64 characters and an individual alphabet.\n    iex> Nanoid.generate(64, \"abcdef123\")\n    \"aabbaca3c11accca213babed2bcd1213efb3e3fa1ad23ecbf11c2ffc123f3bbe\"","ref":"Nanoid.html#generate/2-example","title":"Example - Nanoid.generate/2","type":"function"},{"doc":"Generates a non-secure NanoID using the default alphabet.","ref":"Nanoid.html#generate_non_secure/0","title":"Nanoid.generate_non_secure/0","type":"function"},{"doc":"Generate a non-secure NanoID with the default size of 21 characters.\n    iex> Nanoid.generate_non_secure()\n    \"mJUHrGXZBZpNX50x2xkzf\"","ref":"Nanoid.html#generate_non_secure/0-example","title":"Example - Nanoid.generate_non_secure/0","type":"function"},{"doc":"Generates a non-secure NanoID using the default alphabet.","ref":"Nanoid.html#generate_non_secure/1","title":"Nanoid.generate_non_secure/1","type":"function"},{"doc":"Generate a non-secure NanoID with a custom size of 64 characters.\n    iex> Nanoid.generate_non_secure(64)\n    \"wk9fsUrhK9k-MxY0hLazRKpcSlic8XYDFusks7Jb8FwCVnoQaKFSPsmmLHzP7qCX\"","ref":"Nanoid.html#generate_non_secure/1-example","title":"Example - Nanoid.generate_non_secure/1","type":"function"},{"doc":"Generate a non-secure NanoID using a custom size and an individual alphabet.","ref":"Nanoid.html#generate_non_secure/2","title":"Nanoid.generate_non_secure/2","type":"function"},{"doc":"Generate a non-secure NanoID with the default size of 21 characters and an individual alphabet.\n    iex> Nanoid.generate_non_secure(21, \"abcdef123\")\n    \"d1dcd2dee333cae1bfdea\"\n\nGenerate a non-secure NanoID with custom size of 64 characters and an individual alphabet.\n    iex> Nanoid.generate_non_secure(64, \"abcdef123\")\n    \"aabbaca3c11accca213babed2bcd1213efb3e3fa1ad23ecbf11c2ffc123f3bbe\"","ref":"Nanoid.html#generate_non_secure/2-example","title":"Example - Nanoid.generate_non_secure/2","type":"function"},{"doc":"Configuration module used by NanoID generators to get the required configuration.","ref":"Nanoid.Configuration.html","title":"Nanoid.Configuration","type":"module"},{"doc":"Returns the default alphabet of a nanoid used by the generators.","ref":"Nanoid.Configuration.html#default_alphabet/0","title":"Nanoid.Configuration.default_alphabet/0","type":"function"},{"doc":"iex> Nanoid.Configuration.default_alphabet()\n    \"_-0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ\"","ref":"Nanoid.Configuration.html#default_alphabet/0-example","title":"Example - Nanoid.Configuration.default_alphabet/0","type":"function"},{"doc":"Returns the length of the default alphabet.","ref":"Nanoid.Configuration.html#default_alphabet_length/0","title":"Nanoid.Configuration.default_alphabet_length/0","type":"function"},{"doc":"iex> Nanoid.Configuration.default_alphabet_length()\n    64","ref":"Nanoid.Configuration.html#default_alphabet_length/0-example","title":"Example - Nanoid.Configuration.default_alphabet_length/0","type":"function"},{"doc":"Returns the default mask used by the secure generator.","ref":"Nanoid.Configuration.html#default_mask/0","title":"Nanoid.Configuration.default_mask/0","type":"function"},{"doc":"iex> Nanoid.Configuration.default_mask()\n    63","ref":"Nanoid.Configuration.html#default_mask/0-example","title":"Example - Nanoid.Configuration.default_mask/0","type":"function"},{"doc":"Returns the default size of a nanoid used by the generators.","ref":"Nanoid.Configuration.html#default_size/0","title":"Nanoid.Configuration.default_size/0","type":"function"},{"doc":"iex> Nanoid.Configuration.default_mask()\n    21","ref":"Nanoid.Configuration.html#default_size/0-example","title":"Example - Nanoid.Configuration.default_size/0","type":"function"},{"doc":"Generate an URL-friendly unique ID. This method use the non-secure, predictable random generator.\nBy default, the ID will have 21 symbols with a collision probability similar to UUID v4.","ref":"Nanoid.NonSecure.html","title":"Nanoid.NonSecure","type":"module"},{"doc":"Generates a non-secure NanoID using the default alphabet.","ref":"Nanoid.NonSecure.html#generate/1","title":"Nanoid.NonSecure.generate/1","type":"function"},{"doc":"Generate a non-secure NanoID with the default size of 21 characters.\n    iex> Nanoid.NonSecure.generate()\n    \"mJUHrGXZBZpNX50x2xkzf\"\n\nGenerate a non-secure NanoID with a custom size of 64 characters.\n    iex> Nanoid.NonSecure.generate(64)\n    \"wk9fsUrhK9k-MxY0hLazRKpcSlic8XYDFusks7Jb8FwCVnoQaKFSPsmmLHzP7qCX\"","ref":"Nanoid.NonSecure.html#generate/1-example","title":"Example - Nanoid.NonSecure.generate/1","type":"function"},{"doc":"Generate a non-secure NanoID using a custom size and an individual alphabet.","ref":"Nanoid.NonSecure.html#generate/2","title":"Nanoid.NonSecure.generate/2","type":"function"},{"doc":"Generate a non-secure NanoID with the default size of 21 characters and an individual alphabet.\n    iex> Nanoid.NonSecure.generate(21, \"abcdef123\")\n    \"d1dcd2dee333cae1bfdea\"\n\nGenerate a non-secure NanoID with custom size of 64 characters and an individual alphabet.\n    iex> Nanoid.NonSecure.generate(64, \"abcdef123\")\n    \"aabbaca3c11accca213babed2bcd1213efb3e3fa1ad23ecbf11c2ffc123f3bbe\"","ref":"Nanoid.NonSecure.html#generate/2-example","title":"Example - Nanoid.NonSecure.generate/2","type":"function"},{"doc":"Generate a secure URL-friendly unique ID. This method uses the secure and non predictable random generator.\nBy default, the ID will have 21 symbols with a collision probability similar to UUID v4.","ref":"Nanoid.Secure.html","title":"Nanoid.Secure","type":"module"},{"doc":"Generates a secure NanoID using the default alphabet.","ref":"Nanoid.Secure.html#generate/1","title":"Nanoid.Secure.generate/1","type":"function"},{"doc":"Generate a NanoID with the default size of 21 characters.\n    iex> Nanoid.Secure.generate()\n    \"mJUHrGXZBZpNX50x2xkzf\"\n\nGenerate a secure NanoID with a custom size of 64 characters.\n    iex> Nanoid.Secure.generate(64)\n    \"wk9fsUrhK9k-MxY0hLazRKpcSlic8XYDFusks7Jb8FwCVnoQaKFSPsmmLHzP7qCX\"","ref":"Nanoid.Secure.html#generate/1-example","title":"Example - Nanoid.Secure.generate/1","type":"function"},{"doc":"Generates a secure NanoID using a custom size and an individual alphabet.","ref":"Nanoid.Secure.html#generate/2","title":"Nanoid.Secure.generate/2","type":"function"},{"doc":"Generate a secure NanoID with the default size of 21 characters and an individual alphabet.\n    iex> Nanoid.Secure.generate(21, \"abcdef123\")\n    \"d1dcd2dee333cae1bfdea\"\n\nGenerate a secure NanoID with custom size of 64 characters and an individual alphabet.\n    iex> Nanoid.Secure.generate(64, \"abcdef123\")\n    \"aabbaca3c11accca213babed2bcd1213efb3e3fa1ad23ecbf11c2ffc123f3bbe\"","ref":"Nanoid.Secure.html#generate/2-example","title":"Example - Nanoid.Secure.generate/2","type":"function"},{"doc":"# Nanoid port for Elixir [![Build Status](https://travis-ci.org/railsmechanic/nanoid.svg?branch=master)](https://travis-ci.org/railsmechanic/nanoid)\n\nElixir port of NanoID ([https://github.com/ai/nanoid](https://github.com/ai/nanoid)), a tiny, secure URL-friendly unique string ID generator.\n\n**Safe.** It uses cryptographically strong random APIs and tests distribution of symbols.\n\n**Compact.** It uses a larger alphabet than UUID `(A-Za-z0-9_-)`. So ID size was reduced from 36 to 21 symbols.","ref":"readme.html","title":"Nanoid port for Elixir","type":"extras"},{"doc":"The package can be installed as Hex package:\n\n  1. Add nanoid to your list of dependencies in `mix.exs`:\n\n  ```elixir\n  def deps do\n    [{:nanoid, \"~> 2.1.0\"}]\n  end\n  ```\n\n  2. Run `mix deps.get` to fetch the package from hex","ref":"readme.html#installation","title":"Installation - Nanoid port for Elixir","type":"extras"},{"doc":"With version 2.0.0 of nanoid, **[@ai](https://github.com/ai/nanoid)** introduces a new `non-secure` way of creating NanoIDs.\nIn order to keep this port close to the original, this possibility was also introduced in this port.\nTo ensure a certain level of security, `nanoid` uses per default the `secure` token generator.\nBut according to your preferences, if you don't need \"cryptographically strong random tokens\", just use the `non-secure` token generator.","ref":"readme.html#introducing-a-new-generator","title":"Introducing a new generator - Nanoid port for Elixir","type":"extras"},{"doc":"Starting with version 2.0.0 of nanoid for Elixir it's possible to use `config.exs` to configure nanoid defaults e.g. for different environments.\n\n```elixir\nconfig :nanoid,\n  size: 21,\n  alphabet: \"_-0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ\"\n```\n\nAfter changing configuration, remember to re-compile nanoid with following command:\n\n```sh\n$ mix deps.compile nanoid --force\n```\n\n> Why re-compile? Continuously reading the configuration via `Application.get_env/3` has [a significant effect](https://github.com/railsmechanic/nanoid/issues/6#issuecomment-644774144) on the speed of nanoid. [Compiling the default configuration into byte-code](https://github.com/railsmechanic/nanoid/blob/d606738d3c8bf002121ea3249f35d2c648ffa6e2/lib/nanoid/configuration.ex#L7) will eliminate the effect.","ref":"readme.html#configuration","title":"Configuration - Nanoid port for Elixir","type":"extras"},{"doc":"#","ref":"readme.html#usage","title":"Usage - Nanoid port for Elixir","type":"extras"},{"doc":"##","ref":"readme.html#using-the-secure-default-generator","title":"Using the \"secure\" (default) generator - Nanoid port for Elixir","type":"extras"},{"doc":"Generate a secure NanoID with the default size of 21 characters.\n```elixir\niex> Nanoid.generate()\n\"mJUHrGXZBZpNX50x2xkzf\"\n```\n\nGenerate a secure NanoID with a custom size of 64 characters.\n```elixir\niex> Nanoid.generate(64)\n\"wk9fsUrhK9k~MxY0hLazRKpcSlic8XYDFusks7Jb8FwCVnoQaKFSPsmmLHzP7qCX\"\n```\n\n##","ref":"readme.html#generate-secure-nanoids-of-custom-size-by-using-the-default-alphabet","title":"Generate secure NanoIDs of custom size by using the default alphabet - Nanoid port for Elixir","type":"extras"},{"doc":"Generate a secure NanoID with the default size of 21 characters and an individual alphabet.\n```elixir\niex> Nanoid.generate(21, \"abcdef123\")\n\"d1dcd2dee333cae1bfdea\"\n```\n\nGenerate a secure NanoID with custom size of 64 characters and an individual alphabet.\n```elixir\niex> Nanoid.generate(64, \"abcdef123\")\n\"aabbaca3c11accca213babed2bcd1213efb3e3fa1ad23ecbf11c2ffc123f3bbe\"\n```\n\n#","ref":"readme.html#generate-secure-nanoids-of-custom-size-by-using-a-custom-alphabet","title":"Generate secure NanoIDs of custom size by using a custom alphabet - Nanoid port for Elixir","type":"extras"},{"doc":"##","ref":"readme.html#using-the-non-secure-generator","title":"Using the \"non-secure\" generator - Nanoid port for Elixir","type":"extras"},{"doc":"Generate a non-secure NanoID with the default size of 21 characters.\n```elixir\niex> Nanoid.generate_non_secure()\n\"YBctoD1RuZqv0DLfzDxl2\"\n```\n\nGenerate a non-secure NanoID with a custom size of 64 characters.\n```elixir\niex> Nanoid.generate_non_secure(64)\n\"D2WBHGWQOVds4YKuErmOGJ-oYfp5rik5Z-qo7kN1Dw3gv_1qQs6POmhqZdabkf8s\"\n```\n\n##","ref":"readme.html#generate-non-secure-nanoids-of-custom-size-by-using-the-default-alphabet","title":"Generate non-secure NanoIDs of custom size by using the default alphabet - Nanoid port for Elixir","type":"extras"},{"doc":"Generate a non-secure NanoID with the default size of 21 characters and an individual alphabet.\n```elixir\niex> Nanoid.generate_non_secure(21, \"abcdef123\")\n\"b12c2fac2bdbcdfcfb2da\"\n```\n\nGenerate a non-secure NanoID with custom size of 64 characters and an individual alphabet.\n```elixir\niex> Nanoid.generate_non_secure(64, \"abcdef123\")\n\"dfc1ed3ea22bed1c3c2df2eb21bbd33efdfae3abd3ca2abcca1efcfbf31a3b3f\"\n```","ref":"readme.html#generate-non-secure-nanoids-of-custom-size-and-with-a-custom-alphabet","title":"Generate non-secure NanoIDs of custom size and with a custom alphabet - Nanoid port for Elixir","type":"extras"},{"doc":"The MIT License (MIT). Please see [License File](LICENSE.md) for more information.","ref":"readme.html#license","title":"License - Nanoid port for Elixir","type":"extras"}]}